#include "stdafx.h"	// for MFC
#include "BitmapUtil.h"


void MakeBitmapFileHeader(BITMAPINFOHEADER bmih,BITMAPFILEHEADER &bmfh)
{
	bmfh.bfType = 'B' + ('M'<<8);
	bmfh.bfOffBits = 0x36;
	if (bmih.biBitCount<=8) {
		bmfh.bfOffBits += sizeof(COLORREF) * (1 << bmih.biBitCount);
	}

	bmfh.bfSize = bmfh.bfOffBits + bmih.biSizeImage;
	bmfh.bfReserved1 = 0x00;
	bmfh.bfReserved2 = 0x00;
}


void MakeBitmapInfoHeader(long width,long height,unsigned short bitcount,BITMAPINFOHEADER &bmih)
{
	bmih.biSize = 0x28;
	bmih.biWidth = width;
	bmih.biHeight = height;
	bmih.biPlanes = 0x01;
	bmih.biBitCount = bitcount;
	bmih.biCompression = 0x00;
	bmih.biXPelsPerMeter = 0x00;
	bmih.biYPelsPerMeter = 0x00;
	bmih.biClrUsed = 0x00;
	bmih.biClrImportant = 0x00;

	#define ICEIL(dividend, divisor) (((dividend) + ((divisor) - 1)) / (divisor))

	DWORD pixelsPerDW, lineSizeDW;
	if ( bitcount < 8 ) {
		pixelsPerDW = 8 * sizeof(DWORD) / bitcount;
		lineSizeDW = ICEIL(width, pixelsPerDW);
	} else {
		DWORD bytesPerPixel = bitcount / 8;
		lineSizeDW = bytesPerPixel * width;
		lineSizeDW = ICEIL(lineSizeDW, sizeof(DWORD));
	}
	DWORD lineSize = lineSizeDW * sizeof(DWORD);
	DWORD imageSize = lineSize * height;

	bmih.biSizeImage = imageSize;

	#undef ICEIL
}


void MakeBitmapInfo24(long width,long height,BITMAPINFO &bmi)
{
	MakeBitmapInfoHeader(width,height,24,bmi.bmiHeader);
	memset(&bmi.bmiColors,0,sizeof(RGBQUAD));
}
