#ifndef MARKER_DETECTOR_H_
#define MARKER_DETECTOR_H_

#include <windows.h>
#include <stdio.h>
#include <iostream>

#include <AR/ar.h>
#include <AR/param.h>
#include <AR/gsub.h>

#include <math.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>

#pragma comment(lib,"libAR.lib")
#pragma comment(lib,"libARgsub.lib")
#pragma comment(linker,"/NODEFAULTLIB:libcmt.lib")

using namespace std;

typedef struct AR_OBJECT {
	int		id;
	string	name;
	double	width;
	double	px;
	double	py;
	int		area;
	double	cf;
	double	dx;
	double	dy;
	double	vertex[4][2]; // the order is corrected.
	double	X;
	double	Y;
	double	Z;
	double	gltrans[16];
} AR_OBJECT;

typedef struct PATTERN_DATA {
	int		id;
	string	name;
	string	filename;
	double	width;
	bool	enable;
} PATTERN_DATA;

int DetectMarker( ARUint8 *image, int thresh, const vector<PATTERN_DATA> &patt_list, vector<AR_OBJECT> &objects );
int RegisterPattern( const vector<PATTERN_DATA> &pattern_list );
int LoadPatternList( const char *filename, vector<PATTERN_DATA> &pattList );

#endif